package com.fxy.putOut;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.RequiresApi;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.elvishew.xlog.XLog;
import com.fxy.R;
import com.fxy.baselibrary.base.BaseActivity;
import com.fxy.baselibrary.bean.BaseEventBusBean;
import com.fxy.baselibrary.interfaces.OnRxScanerListener;
import com.fxy.baselibrary.qrcode.ActivityScanerCode;
import com.fxy.baselibrary.util.JsonUtil;
import com.fxy.baselibrary.util.StringUtils;
import com.fxy.baselibrary.views.MarqueeTextView;
import com.fxy.bean.ActionBean;
import com.fxy.bean.ScanBean;
import com.fxy.common.CommonDialog;
import com.fxy.common.PictureSelectorUpload;
import com.fxy.constant.BaseConfig;
import com.fxy.constant.EventCode;
import com.fxy.constant.SPCache;
import com.fxy.net.MyDialogCallback;
import com.fxy.net.Urls;
import com.fxy.view.FloatingImageView;
import com.google.zxing.Result;
import com.luck.picture.lib.config.PictureConfig;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;
import sto.android.app.StoJNI;
import sto.android.app.StoPdaKeyEvent;
import sto.android.app.StoTongJNI;

public class QualityInspectionMainActivity extends  BaseActivity implements StoJNI.ScanCallBack {
    /**
     * 列表适配器
     */
    Context mContext = this;

    //单号清除
    @BindView(R.id.ib_order_no_clear)
    ImageButton ibOrderNoClear;

    //单号
    @BindView(R.id.et_order_no)
    EditText etOrderNo;


    //浮动按钮
    @BindView(R.id.iv_drag)
    FloatingImageView iv_drag;



    @BindView(R.id.ll_panorama_area)
    LinearLayout llPanoramaArea;

    @BindView(R.id.ll_label_area)
    LinearLayout llLabelArea;


    @BindView(R.id.ll_damaged_area)
    LinearLayout llDamagedArea;


    @BindView(R.id.radioGroup1)
    RadioGroup radioGroup;



    //扫码扫码动作
    private ScanBean scanBean;



    private Unbinder unbinder;


    //图片列表
    private ArrayList photoList =new ArrayList<>();

    private PictureSelectorUpload currentUpload;

    private PictureSelectorUpload panoramaUpload ;
    private PictureSelectorUpload labelUpload;
    private PictureSelectorUpload damagedUpload;

    //质检结果
    private String categoryName = "完好";

    @Override
    public int getContentViewResId() {
        return R.layout.activity_fxy_quality_inspection;
    }

    @Override
    public boolean showToolBar() {
        return true;
    }

    @Override
    public boolean openEventBus() {
        return true;
    }

    @Override
    protected void getBundleExtras(Bundle bundle) {

    }
    //finish的返回监听
    //这里的requestCode参数，就是上面设置的 1 ，当跳转的页面返回的时候，通过这个加以判断
    //resultCode ,这个参数是在跳转的页面里面规定的，它也是一个int类型的标志
    //第三个参数包含了返回的值
    //如果不需要所跳转的页面返回值，也就不需要这个方法了
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
//        XLog.e("requestCode："+requestCode);
//        XLog.e("resultCode："+resultCode);
//        XLog.e(data);
        if (requestCode == 200 && resultCode == 200)//之前提到的两个标志，在这里显示出了作用
        {
            clearData(true);
        }else if (resultCode==0){
        }

        if (resultCode == RESULT_OK) {
            if (requestCode == PictureConfig.CHOOSE_REQUEST) {// 图片选择结果回调
                if (currentUpload!=null){
                    currentUpload.getSelectImg(data);
                }

            }
        }
    }


    /**
     * EventBus接收信息的方法，开启后才会调用(非粘性事件)
     *
     * @param event
     */
    @Override
    protected void EventBean(BaseEventBusBean event) {
//        XLog.e("----------接收返回--------------");
//        XLog.e("接收返回："+event.getEventCode());
        if (event != null && event.getEventCode() == EventCode.displacement_refresh){

        }
    }

    @Override
    public boolean isPlayMusic() {
        return true;
    }

    @Override
    protected void initView() {
        unbinder = ButterKnife.bind(this);
        setTitleName("标准质检");

        initEdit();
        //监听浮动按钮
        iv_drag.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(!iv_drag.isDrag()){
                    ActivityScanerCode.setScanerListener(mScanerListener);
                    ActivityScanerCode.intent2Activity(mContext, BaseConfig.COMMON_SCANNER_ONLY);
                }
            }
        });

        initUpload();


    }

    /**
     * 初始化上传文件
     */
    private void initUpload(){

        RecyclerView rvPanoramaShowImg = (RecyclerView)llPanoramaArea.findViewById(R.id.rv_show_img);
        RecyclerView rvLabelShowImg = (RecyclerView)llLabelArea.findViewById(R.id.rv_show_img);
        RecyclerView rvDamagedShowImg = (RecyclerView)llDamagedArea.findViewById(R.id.rv_show_img);

        panoramaUpload  = setItemPicture("panorama",rvPanoramaShowImg);
        labelUpload     = setItemPicture("label",rvLabelShowImg);
        damagedUpload   = setItemPicture("damaged",rvDamagedShowImg);
    }


    /*
     * 设置radio的点击事件，当点击的时候显示文字
     */
    public void onRadioButtonClicked(View view) {
        RadioButton button = (RadioButton) view;
        boolean isChecked = button.isChecked();


        switch (view.getId()) {
            case R.id.rb_intact:
                categoryName = "完好";
                llDamagedArea.setVisibility(View.GONE);
                break;
            case R.id.rb_breakage:
                categoryName = "破损";
                llDamagedArea.setVisibility(View.VISIBLE);
                break;

            default:
                break;
        }
    }

    /**
     * 设置多个上传文件
     * @param actionType String
     * @param showImg RecyclerView
     */
    private PictureSelectorUpload setItemPicture(String actionType,RecyclerView showImg){
        PictureSelectorUpload pictureUpload = new PictureSelectorUpload(QualityInspectionMainActivity.this,showImg,"tally",1);
        pictureUpload.setActionType(actionType);
        pictureUpload.setCompress(true,100,500);
        pictureUpload.setOnChangeListener(new PictureSelectorUpload.UploadChangeListener() {
            @Override
            public void uploadResult(boolean State,String actionType) {
                if (State) {
                    System.out.println("文件上传回调成功");
                } else {
                    System.out.println("文件上传失败");
                }
            }

            @Override
            public void uploadActionType(String actionType) {

                System.out.println("actionType："+actionType);
                switch (actionType){
                    case "panorama":
                        currentUpload = panoramaUpload;
                        break;
                    case "label":
                        currentUpload = labelUpload;
                        break;
                    case "damaged":
                        currentUpload = damagedUpload;
                        break;
                }

            }
        });
        return  pictureUpload;
    }






    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        //XLog.e("Action："+event.getAction()+"---event:"+event.getKeyCode());
        if ((event.getKeyCode()==KeyEvent.KEYCODE_DPAD_CENTER )  && event.getAction() == KeyEvent.ACTION_DOWN){
            if(validate()){
                doPutIn();
            }
            return true;
        }
        return super.dispatchKeyEvent(event);
    }

    //监听按键
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        //XLog.e("监听按键："+keyCode);XLog.e(event);
        if (scanBean.getIsBroadcast()==0 && StoTongJNI.getIns(mContext).getEventFuction(keyCode)  == StoPdaKeyEvent.KEYCODE_SCAN
                && event.getRepeatCount() == 0) {

            if (StoTongJNI.getIns(mContext).GetScannerIsScanning()) {
//
            } else {
                StoTongJNI.getIns(mContext).SetScannerStart();
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    @SuppressLint("HandlerLeak")
    Handler scanHandler = new Handler() {

        @Override
        public void handleMessage(Message msg) {
            // TODO Auto-generated method stub
            if (msg.obj != null) {

                String scanResult = msg.obj.toString().trim();
                if (!scanResult.isEmpty()){
                    setScanResult(scanResult);
                }
            }

        }

    };
    @Override
    public void onScanResults(String str) {
        Message msg = new Message();
        msg.obj = str;
        scanHandler.sendMessage(msg);


    }


    @Override
    public void onScanResults(String str, int type) {

    }
    /**
     * 定义广播接受
     */
    BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String scanResult = intent.getStringExtra(scanBean.getDataName());
            if (scanResult==null){return; }
            String scanStatus = "";
            if (!scanBean.getStatusName().isEmpty()){
                scanStatus = intent.getStringExtra(scanBean.getStatusName());
            }else{
                scanStatus = scanResult.isEmpty()? "" : "ok"; //有值 默认是扫码成功;
            }

            //新大陆(MT65,MT90) 需要手动关闭
            if (!scanBean.getActionStop().isEmpty()){
                Intent stopIntent = new Intent(scanBean.getActionStop());
                mContext.sendBroadcast(stopIntent);
            }

            if ("ok".equals(scanStatus)){
                setScanResult(scanResult);
            }else{
                showErrorToast(getString(R.string.scan_failed));
            }
        }
    };

    /**
     * 注册广播
     */
    private void initReceiver(){

        try {

            String scanStr = getScanSetting();
            scanBean = JsonUtil.getObject(scanStr, ScanBean.class);
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播

            if (is_broadcast ==1){
                IntentFilter mFilter = new IntentFilter(scanBean.getAction());
                this.registerReceiver(mReceiver, mFilter);
            }else{
                //不广播进行处理 jni模式
                String pdaBrand = StoTongJNI.getmPdaBrand();
                if (!pdaBrand.isEmpty()){
                    StoTongJNI.getIns(this).setmScanCB(this);
                    StoTongJNI.getIns(this).SetScannerOn();
                }
            }


        }catch (Exception e) {
            showErrorToast("获取扫码配置失败"+e.getMessage());
            XLog.e("获取扫码配置失败:" + e.getMessage());
        }
    }


    //统一按钮回调
    public void callbackEditor(View v){
        switch (v.getId()) {
            case R.id.et_order_no:
                qualityTrackingNumber();
                break;
            default:
        }
    }





    private void initEdit() {
        List<EditText> list = new ArrayList<>();
        list.add(etOrderNo);
        unifyEdit(list);
    }

    private OnRxScanerListener mScanerListener = new OnRxScanerListener() {
        @Override
        public void onSuccess(String type, Result result) {
            String scanResult = result.getText();
            switch (type){
                case BaseConfig.COMMON_SCANNER_ONLY:
                    setScanResult(scanResult);

                    break;
            }
        }
        @Override
        public void onFail(String type, String message) {

        }
    };

    //把扫描结果赋值
    private void setScanResult(String scanResult){

        //获取焦点的view对象
        View view=getWindow().getDecorView().findFocus();
        //如果是EditText
        if(view instanceof EditText)
        {
            ((EditText) view).setText(scanResult);
            //执行回调
            callbackEditor(view);
        }
    }


    public void qualityTrackingNumber() {
        //校验数据
        if(!checkNull(etOrderNo)){
            setEditTextFocused(etOrderNo,true);
            showWarningToast(etOrderNo.getHint().toString());
            return ;
        }

        try {
            final String tracking_number = etOrderNo.getText().toString().trim();
            JSONObject param = new JSONObject();
            param.put("tracking_number",tracking_number);



            if (!checkRepeat(Urls.FXY_QUALITY_TRACKING_NUMBER+(param.toString()))){return;}

            OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FXY_QUALITY_TRACKING_NUMBER)
                    .upJson(param)
                    .execute(new MyDialogCallback(this, true, true) {
                        @Override
                        public void onSuccess(Response<String> response) {
                            super.onSuccess(response);
                            try {
                                ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);
                                JSONObject result = new JSONObject();
                                if (bean.data!=null && !bean.data.isEmpty() && !bean.data.equals("[]")){
                                    result = new JSONObject(bean.data);
                                    if (result.has("deal_tracking_number")){
                                        etOrderNo.setText(result.getString("deal_tracking_number"));
                                    }
                                }

                                if(bean.code == 1){
                                    showSuccessToast(bean.msg);
                                }else{
                                    showWarningToast(bean.msg);
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                                XLog.e("请求入库返回错误",e.getMessage());
                            }
                        }
                    });
        } catch (JSONException e) {
            showEmptyView("请求入库失败:"+e.getMessage());
            e.printStackTrace();
        }


    }

    public void doPutIn() {
        //校验数据
        if (!validate()){
            return;
        }

        try {
            final String tracking_number = etOrderNo.getText().toString().trim();
            JSONObject param = new JSONObject();
            param.put("tracking_number",tracking_number);
            param.put("category_name",categoryName);

            param.put("img_1",panoramaUpload.getPhotoList().get(0));
            param.put("img_2",labelUpload.getPhotoList().get(0));

            if (categoryName.equals("破损")){
                param.put("img_3",damagedUpload.getPhotoList().get(0));
            }

            if (!checkRepeat(Urls.FXY_QUALITY_SUBMIT+(param.toString()))){return;}

            OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FXY_QUALITY_SUBMIT)
                    .upJson(param)
                    .execute(new MyDialogCallback(this, true, true) {
                        @Override
                        public void onSuccess(Response<String> response) {
                            super.onSuccess(response);
                            try {
                                ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);


                                if(bean.code == 1){
                                    JSONObject result = new JSONObject(bean.data);
                                    showSuccessToast(bean.msg);
                                    Bundle bundle = new Bundle();
                                    bundle.putString("container_type",result.getString("result_txt"));
                                    bundle.putInt("quality_order_id",result.getInt("quality_order_id"));
                                    intentPageResult(QualityInspectionMainActivity.this, QualityVolumeMainActivity.class, bundle,200);
                                }else{

                                    showWarningToast(bean.msg);

                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                                XLog.e("请求入库返回错误",e.getMessage());
                            }
                        }
                    });
        } catch (JSONException e) {
            showEmptyView("请求入库失败:"+e.getMessage());
            e.printStackTrace();
        }


    }

    /*
     * 校验必录
     */
    private boolean validate(){

        if(!checkNull(etOrderNo)){
            setEditTextFocused(etOrderNo,true);
            showWarningToast(etOrderNo.getHint().toString());
            return false;
        }

        if (panoramaUpload.getPhotoList().size()==0){
            showWarningToast("请选择全景图");
            return false;
        }

        if (labelUpload.getPhotoList().size()==0){
            showWarningToast("请选择面单图");
            return false;
        }

        if (categoryName.equals("破损") && damagedUpload.getPhotoList().size()==0){
            showWarningToast("请选择破损图");
            return false;
        }


        return true;
    }

    //清除订单信息
    private void clearData(boolean isAll) {
        etOrderNo.setText("");
        etOrderNo.requestFocus();
        setEditTextNormal(etOrderNo,true);

        llDamagedArea.setVisibility(View.GONE);
        if (currentUpload != null){
            currentUpload.emptyRemake();//清空图片
        }

        if (panoramaUpload!=null){
            panoramaUpload.emptyRemake();//清空图片
        }

        if (labelUpload!=null){
            labelUpload.emptyRemake();//清空图片
        }

        if (damagedUpload!=null){
            damagedUpload.emptyRemake();//清空图片
        }

        //设置默认选中
        categoryName = "完好";
        RadioButton rb_checked = (RadioButton) radioGroup.findViewById(R.id.rb_intact);
        rb_checked.setChecked(true);

        photoList.clear();
    }

    @OnClick({R.id.btn_confirm})
    public void onViewClicked(View view) {
        Bundle bundle = new Bundle();
        switch (view.getId()) {
            case R.id.btn_confirm:
                doPutIn();
                break;

//            case R.id.tv_clear_pictures:
//                currentUpload.emptyRemake();
//                break;
            default:
                break;
        }
    }

    /**
     * 统一设置Edit监听
     * @param  list
     */
    public void unifyEdit(List<EditText> list){
        for (int i=0;i<list.size();i++){
            EditText editText = list.get(i);

            LinearLayout linearLayout = (LinearLayout)editText.getParent();
            ImageButton imageButton = getChildImageButton(linearLayout);



            //监听按确定
            editText.setOnEditorActionListener(new TextView.OnEditorActionListener() {
                @Override
                public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                    //XLog.e("actionId："+actionId);
                    if (actionId == EditorInfo.IME_ACTION_SEND || actionId == EditorInfo.IME_ACTION_DONE   ) {
                        if (v.getText().toString().trim().isEmpty()) {
                            setEditTextFocused(v,true);
                            showWarningToast(v.getHint().toString());
                            return false;
                        }else{
                            setEditTextNormal(v,true);
                        }

                        callbackEditor(v);

                        return false;
                    }
                    return false;
                }
            });
            editText.addTextChangedListener(new TextWatcher() {
                public void onTextChanged(CharSequence s, int start, int before, int count) {
                    EditText currentEditText = null;
                    ImageButton currentImage = null;
                    //获取焦点的view对象
                    View view=getWindow().getDecorView().findFocus();
                    //如果是EditText
                    if(view instanceof EditText){
                        currentEditText = (EditText) view;
                        currentImage = getChildImageButton((LinearLayout)currentEditText.getParent());
                    }

                    if (s.length() > 0  ) {

                        if (currentImage !=null ){
                            currentImage.setVisibility(View.VISIBLE);
                        }
                        if (currentEditText!=null){
                            setEditTextNormal(currentEditText,true);
                        }

                    } else {
                        if (currentImage !=null ){
                            currentImage.setVisibility(View.INVISIBLE);
                        }
                        if (currentEditText!=null){
                            setEditTextFocused(currentEditText,true);
                        }
                    }
                }

                public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                }

                public void afterTextChanged(Editable s) {

                }
            });

            if (imageButton !=null ){
                unifyClearEdit(imageButton);
            }
        }
    }


    @Override
    protected void onDestroy() {
        unbinder.unbind();
        panoramaUpload.removeHandler();
        labelUpload.removeHandler();
        damagedUpload.removeHandler();

        super.onDestroy();
    }
    @Override
    protected void onResume() {
        super.onResume();
        initReceiver();
    }
    @Override
    protected void onPause() {
        super.onPause();
        //销毁在onResume()方法中的广播
        try {
            //停止扫描
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播
            if (is_broadcast==0){
                StoTongJNI.getIns(mContext).SetScannerStop();
                StoTongJNI.getIns(mContext).SetScannerOff();
            }else{
                unregisterReceiver(mReceiver);
            }
        }catch (Exception e){
            XLog.e("销毁广播失败：",e.getMessage());
        }
    }


}
